﻿using System.ComponentModel;
using System.Runtime.CompilerServices;
using System.Xml.Serialization;
using Configuration.Properties;

namespace Configuration
{
    public class WhiteList : INotifyPropertyChanged
    {
#region Public Events & Delegates

        public event PropertyChangedEventHandler PropertyChanged;

#endregion

#region Public Enums, Properties and Fields

        [XmlElement(ElementName = "Whitelist")]
        public ObservableUniqueCollection<string> Whitelist
        {
            get => _whitelist;
            set
            {
                if (Equals(value, _whitelist))
                {
                    return;
                }

                _whitelist = value;
                OnPropertyChanged();
            }
        }

#endregion

#region Private Delegates, Events, Enums, Properties, Indexers and Fields

        private ObservableUniqueCollection<string> _whitelist = new ObservableUniqueCollection<string>();

#endregion

#region Constructors, Destructors and Finalizers

        [UsedImplicitly]
        public WhiteList()
        {
        }

#endregion

#region Private Methods

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }

#endregion
    }
}
